<template>
  <q-layout view="hHh LpR fFf" class="bg-grey-2">
    <q-layout-header class="bg-white">
      <q-toolbar class="bg-white">
        <router-link :to="{ name: 'home' }" class="row">
          <img src="~assets/logo.png" alt="iRewind" class="gt-sm" />
          <img src="~assets/logo_small.png" alt="iRewind" class="lt-md" />
        </router-link>
        <q-toolbar-title>
          <q-search class="q-my-none" v-if="routeActive" v-model.trim="search" :debounce="200" placeholder="Search My Projects" hide-underline autofocus clearable />
          <q-select class="q-my-none" v-else v-model="location" :options="locationOptions" hide-underline filter autofocus-filter />
        </q-toolbar-title>
        <q-btn round size="md" outline color="faded" icon="chat" @click="toggleChat()" class="on-left" />
        <q-btn flat round @click="toggleMenu()" color="white" v-if="credentials && credentials.info && (credentials.info.picture || credentials.info.email)">
          <img v-if="credentials.info.picture" :src="credentials.info.picture.replace(/^https?:/,'')" class="img-round" style="width: 40px; height: 40px;" />
          <gravatar v-else :email="credentials.info.email" :size="40" default-img="identicon" class="img-round" />
        </q-btn>
      </q-toolbar>
      <q-tabs v-if="!routeActive" align="left" position="top" color="primary" inverted>
        <q-route-tab slot="title" :to="{ name: 'overview' }" exact label="Overview" />
        <q-route-tab slot="title" :to="{ name: 'channel' }" exact label="Channel" />
        <q-route-tab slot="title" :to="{ name: 'upload' }" exact label="Upload Videos" />
        <q-route-tab slot="title" :to="{ name: 'uplmeta' }" exact label="Upload Metadata" />
        <q-route-tab slot="title" :to="{ name: 'publish' }" exact label="Publish" />
        <q-route-tab slot="title" :to="{ name: 'videos' }" exact label="Videos" />
        <q-route-tab slot="title" :to="{ name: 'analytics' }" exact label="Analytics" />
        <q-route-tab slot="title" :to="{ name: 'reporting' }" label="Reporting" v-if="credentials.token" />
      </q-tabs>
    </q-layout-header>

    <q-layout-drawer side="right" v-model="menuOpen" overlay behavior="desktop">
      <q-list no-border class="no-padding">
        <q-list-header class="menu-title lt-lg">
          iRewind Admin
        </q-list-header>
        <q-item v-if="credentials && credentials.info">
          <q-item-side>
            <q-item-tile icon>
              <img v-if="credentials.info.picture" :src="credentials.info.picture.replace(/^https?:/,'')" class="img-round" style="width: 24px; height: 24px;" />
              <gravatar v-else-if="credentials && credentials.info && credentials.info.email" :email="credentials.info.email" :size="24" default-img="identicon" class="img-round" />
            </q-item-tile>
          </q-item-side>
          <q-item-main :label="credentials.info.name" :sublabel="credentials.info.email" />
        </q-item>
        <q-item link :to="{name: 'home'}">
          <q-item-side icon="home" />
          <q-item-main label="My Projects" />
        </q-item>
        <q-item link @click.native="logout(), menuOpen = false">
          <q-item-side icon="power_settings_new" />
          <q-item-main label="Logout" />
        </q-item>
      </q-list>
    </q-layout-drawer>

    <q-layout-drawer side="right" v-model="chatOpen" overlay behavior="desktop">
      <iframe v-if="chatOpen" ref="chatIframe" frameborder="0" allowfullscreen :class="{'absolute-full fit': chatLoaded }" @chatLoaded="chatLoaded = true"/>
      <q-inner-loading :visible="!chatLoaded" />
    </q-layout-drawer>

    <q-layout-footer v-if="routeActive" class="row q-py-xs bg-white">
      <q-btn icon="add_circle" label="Add new channel" color="primary" class="q-ml-xs gt-sm" @click="addChannel" />
      <q-btn icon="add_circle" color="primary" class="q-ml-xs lt-md" @click="addChannel" />
      <div class="col text-center">
        <q-pagination class="inline" v-model="locationsPage" :max="locationsPageLast" boundaryNumbers directionLinks ellipses :max-pages="locationsPageMax" />
      </div>
    </q-layout-footer>

    <q-page-container>
      <q-page padding v-if="routeActive" class="height-0">
        <q-scroll-area class="full-height" :thumb-style="{right: '0', borderRadius: '4px', background: '#d12', opacity: .6, width: '10px'}">
          <div class="q-headline q-mb-sm">My Projects</div>
          <div class="q-ma-xs">
            <div class="row gutter-sm">
              <div class="col-12 col-md-6 col-lg-4 col-xl-3 row" v-for="l in locationsPaginated" :key="l.id">
                <q-card class="row col cursor-pointer" @click.native="location = l">
                  <q-card-media overlay-position="bottom" class="col bg-white row">
                    <img v-if="l.PICTURE_URL" :src="l.PICTURE_URL.replace(/^https?:/,'')" />
                    <img v-else src="~assets/channelbg.jpg" />
                    <q-card-title slot="overlay" class="bg-white">
                      <div class="text-truncate text-dark" :title="l.name">{{l.name}}</div>
                      <div class="text-truncate text-faded" slot="subtitle" :title="l.country">{{l.country}}</div>
                    </q-card-title>
                  </q-card-media>
                </q-card>
              </div>
            </div>
          </div>
        </q-scroll-area>
      </q-page>

      <transition enter-active-class="animated fadeIn" leave-active-class="animated fadeOut" mode="out-in" :duration="300">
        <router-view />
      </transition>
    </q-page-container>
  </q-layout>
</template>

<style scoped lang="stylus">
  .q-card-media
    padding-top 16px
    padding-bottom 80px
    height 35vh
  .q-card-media > img
    max-height 100%
    width auto
    margin auto
  .q-card-media-overlay
    background rgba(255, 255, 255, .7)
</style>

<script>
  import { mapActions, mapState } from 'vuex';
  import { stringify } from 'qs';
  import Gravatar from 'vue-gravatar';
  import { getRejectionMessage } from '../../utils';

  export default {
    name: 'irwLayout',
    components: {
      Gravatar,
    },
    data() {
      return {
        menuOpen: false,
        chatOpen: false,
        chatLoaded: false,
        search: '',
        locationsPage: 1,
        locationsPageSize: 24,
      };
    },
    computed: {
      ...mapState('auth', [
        'credentials',
      ]),
      ...mapState('location', [
        'locations',
      ]),
      location: {
        get() {
          return this.$store.state.location.location;
        },
        set(location) {
          if (location) {
            this.setLocation(location);
          } else {
            this.clearLocation();
          }
        },
      },
      routeActive() {
        return this.$route.name === 'home';
      },
      locationsFiltered() {
        const search = this.search.toLowerCase();
        return this.locations.filter((l) => `${ l.id }#${ l.name }#${ l.country }`.toLowerCase().indexOf(search) !== -1);
      },
      locationsPageLast() {
        return Math.max(1, Math.ceil(this.locationsFiltered.length / this.locationsPageSize));
      },
      locationsPaginated() {
        const from = Math.max(0, this.locationsPage - 1) * this.locationsPageSize;
        return this.locationsFiltered.slice(from, from + this.locationsPageSize);
      },
      locationOptions() {
        return this.locations.map((l) => ({
          value: l,
          label: `[${ l.id }] ${ l.name }`,
          stamp: l.country,
        }));
      },
      locationsPageMax() {
        return this.$q.platform.is.mobile ? 7 : 15;
      },
    },
    methods: {
      ...mapActions('auth', [
        'logout',
      ]),
      ...mapActions('location', {
        loadLocations: 'load',
        setLocation: 'set',
        clearLocation: 'clear',
      }),
      toggleChat(status) {
        this.chatOpen = [true, false].indexOf(status) !== -1 ? status : !this.chatOpen;
        if (this.chatOpen) {
          this.menuOpen = false;
          this.$nextTick(() => {
            const iframe = this.$refs.chatIframe;
            if (!iframe) return;
            const doc = (iframe.contentWindow || iframe.documentWindow).document;
            if (!doc) return;
            const [lt, gt] = ['<', '>'];
            let chatName = '';
            let chatEmail = '';
            const chatLocationName = this.location ? this.location.name : '';
            const chatLocationId = this.location ? String(this.location.id) : '';
            if (this.credentials) {
              if (this.credentials.info) {
                chatName = this.credentials.info.name;
                chatEmail = this.credentials.info.email;
              } else {
                chatEmail = this.credentials.username;
              }
            }
            const html = `
              <body id="chat-widget">
                ${ lt }script${ gt }
                  var APP_ID = "rusa572b";

                  window.intercomSettings = {
                      app_id: APP_ID,
                      user_id: "${ chatEmail.split('"').join("'") } - ${ chatLocationId.split('"').join("'") || 'OVERVIEW' }",
                      name: "${ chatName.split('"').join("'") } - ${ chatLocationName.split('"').join("'") || 'OVERVIEW' }",
                      email: "${ chatEmail.split('"').join("'") }",
                    };
                  (function(){var w=window;var ic=w.Intercom;if(typeof ic==="function")
                  {ic('reattach_activator');ic('update',intercomSettings);}else
                  {var d=document;var i=function(){i.c(arguments)};i.q=[];i.c=function(args)
                  {i.q.push(args)};w.Intercom=i;function l()
                  {var s=d.createElement('script');s.type='text/javascript';s.async=true;
                  s.src='https://widget.intercom.io/widget/' + APP_ID;
                  var x=d.getElementsByTagName('script')[0];
                  x.parentNode.insertBefore(s,x);}if(w.attachEvent){w.attachEvent('onload',l);}
                  else{w.addEventListener('load',l,false);}}})()

                  var check = function () {
                    if (!window.Intercom) {
                      setTimeout(check, 100);
                    } else {
                      window.Intercom('show')
                      window.frameElement.dispatchEvent(new CustomEvent('chatLoaded'))
                    }
                  };
                  check();
                ${ lt }/script${ gt }
              </body>
            `;
            doc.open();
            doc.write(html);
            doc.close();
          });
        }
      },
      toggleMenu(status) {
        this.menuOpen = [true, false].indexOf(status) !== -1 ? status : !this.menuOpen;
        if (this.menuOpen) {
          this.chatOpen = false;
        }
      },
      addChannel() {
        this.$q
          .dialog({
            title: 'Add new channel',
            message: 'Provide the name of the new channel to be added.',
            prompt: {
              model: '',
              type: 'text',
            },
            cancel: true,
          })
          .then((title) => {
            if (typeof title !== 'string' || !title.length) {
              throw new Error('You must provide a channel name');
            }
            return this.$http
              .post('/channel/create', stringify({
                channel_title: title,
              }, { arrayFormat: 'brackets' }), {
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
                },
              })
              .then((response) => {
                if (!response.data || !response.data.results || !response.data.results[0]) {
                  throw new Error('There was an error creating channel.');
                }
                return this
                  .loadLocations()
                  .then(() => ({
                    idLocation: response.data.results[0]['@location_id'],
                    title,
                  }));
              })
              .catch((rejection) => getRejectionMessage(rejection, 'There was an error creating channel.'));
          })
          .then(({ idLocation, title }) => {
            this.$q.notify({
              type: 'positive',
              message: `Channel ${ JSON.stringify(title) } created (${ idLocation })`,
              actions: [{
                label: 'Open',
                handler: () => {
                  const location = this.locations.find((l) => l.id === idLocation);
                  if (location) {
                    this.location = location;
                  }
                },
              }],
            });
          })
          .catch((e) => {
            if (e.message) {
              this.$q.notify({
                type: 'negative',
                message: e.message,
              });
            }
          });
      },
    },
    watch: {
      locationsPagelast() {
        this.locationsPage = 1;
      },
      'credentials.token': function userChanged() {
        this.loadLocations();
        this.toggleChat(false);
      },
      'location.name': function locationChanged() {
        this.toggleChat(false);
      },
      chatOpen() {
        this.chatLoaded = false;
      },
    },
    mounted() {
      this.loadLocations();
    },
  };
</script>
